/* ----------------------------------------------------------------------------
This file is part of BlueSky

Copyright (C) 2012 Piotr Polesiuk

Permission is hereby granted, free of charge, to any person obtaining a copy 
of this software and associated documentation files (the "Software"), to deal 
in the Software without restriction, including without limitation the rights 
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
copies of the Software, and to permit persons to whom the Software is 
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in 
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN 
THE SOFTWARE.
---------------------------------------------------------------------------- */

#ifndef SIMULATIONTHREAD_H_INCLUDED
#define SIMULATIONTHREAD_H_INCLUDED

#include <QtCore/QtCore>
#include <BSAction.h>
#include <BSCamera.h>

class Simulation;

class SimulationThread : public QThread
{
	Q_OBJECT

public:

	SimulationThread(Simulation *sim);
	~SimulationThread();

	void stopThread();
	void pause();
	void resume();

protected:

	void run();

private:

	int state;
	BlueSky::Vector3f sunPosition;
	BlueSky::Action *action;
	BlueSky::Camera *camera;

	QMutex pauseMutex;
};

#endif
